# git clone https://github.com/Rick-Moba/rtl8192cu
# git archive 

%global	module	8192cu
%global pname rtl%{module}

Name:		dkms-%{pname}
Version:	4.0.2
Release:	%mkrel 1
Source0:	%{pname}-%{version}.tar.xz

License:	GPLv2
Group:		System/Kernel and hardware
URL:		https://github.com/Rick-Moba/rtl8192cu
Summary:	Driver for Realtek RTL8188CUS (8188C, 8192C) chipset wireless cards 
BuildRoot:	%{_tmppath}/%{name}-%{version}-buildroot

Patch0:		rtl8192cu-makefile.patch

Provides:	%{name}-%{version}
Provides:	kmod(%{pname}.ko) = %{version}
Requires: 	kernel
Requires:   gcc >= 10.2.0
Requires(post):		dkms
Requires(preun):	dkms

Obsoletes:	dkms-%{pname} < %{version}-%{release}

%description
Driver for Realtek RTL8188CUS (8188C, 8192C) chipset wireless cards
rtl8192cu linux driver sources.
Added support for N150MA, ISY, HWNUM-300V2,
Sitecom WLA-2100 and D-link DWA-131 (H/W Ver. B1) devices.
Patched to support up to latest linux kernel (current 5.8). With no debug patch.
*defined RTL8192C_USB_IDS \
	/*=== Realtek demoboard ===*/ \
	{USB_DEVICE(USB_VENDER_ID_REALTEK, 0x8191)},/* Default ID */ \
	/****** 8188CUS ********/ \
	{USB_DEVICE(USB_VENDER_ID_REALTEK, 0x8176)},/* 8188cu 1*1 dongole */ \
	{USB_DEVICE(USB_VENDER_ID_REALTEK, 0x8170)},/* 8188CE-VAU USB minCard */ \
	{USB_DEVICE(USB_VENDER_ID_REALTEK, 0x817E)},/* 8188CE-VAU USB minCard */ \
	{USB_DEVICE(USB_VENDER_ID_REALTEK, 0x817A)},/* 8188cu Slim Solo */ \
	{USB_DEVICE(USB_VENDER_ID_REALTEK, 0x817B)},/* 8188cu Slim Combo */ \
	{USB_DEVICE(USB_VENDER_ID_REALTEK, 0x817D)},/* 8188RU High-power USB Dongle */ \
	{USB_DEVICE(USB_VENDER_ID_REALTEK, 0x8754)},/* 8188 Combo for BC4 */ \
	{USB_DEVICE(USB_VENDER_ID_REALTEK, 0x817F)},/* 8188RU */ \
	{USB_DEVICE(USB_VENDER_ID_REALTEK, 0x818A)},/* RTL8188CUS-VL */ \
	{USB_DEVICE(USB_VENDER_ID_REALTEK, 0x018A)},/* RTL8188CTV */ \
	{USB_DEVICE(USB_VENDER_ID_REALTEK, 0x17C0)}, /* RTK demoboard - USB-N10E */ \
	/****** 8192CUS ********/ \
	{USB_DEVICE(USB_VENDER_ID_REALTEK, 0x8177)},/* 8191cu 1*2 */ \
	{USB_DEVICE(USB_VENDER_ID_REALTEK, 0x8178)},/* 8192cu 2*2 */ \
	{USB_DEVICE(USB_VENDER_ID_REALTEK, 0x817C)},/* 8192CE-VAU USB minCard */ \
	{USB_DEVICE(USB_VENDER_ID_REALTEK, 0x8191)},/* 8192CU 2*2 */ \
	{USB_DEVICE(0x1058, 0x0631)},/* Alpha, 8192CU */ \
	/*=== Customer ID ===*/	 \
	/****** 8188CUS Dongle ********/ \
	{USB_DEVICE(0x2019, 0xED17)},/* PCI - Edimax */ \
	{USB_DEVICE(0x0DF6, 0x0052)},/* Sitecom - Edimax */ \
	{USB_DEVICE(0x7392, 0x7811)},/* Edimax - Edimax */ \
	{USB_DEVICE(0x07B8, 0x8189)},/* Abocom - Abocom */ \
	{USB_DEVICE(0x0EB0, 0x9071)},/* NO Brand - Etop */ \
	{USB_DEVICE(0x06F8, 0xE033)},/* Hercules - Edimax */ \
	{USB_DEVICE(0x06F8, 0xE035)},/* Hercules - Edimax */ \
	{USB_DEVICE(0x103C, 0x1629)},/* HP - Lite-On ,8188CUS Slim Combo */ \
	{USB_DEVICE(0x2001, 0x3308)},/* D-Link - Alpha */ \
	{USB_DEVICE(0x050D, 0x1102)},/* Belkin - Edimax */ \
	{USB_DEVICE(0x050D, 0x11F2)},/* ISY - Edimax */ \
	{USB_DEVICE(0x2019, 0xAB2A)},/* Planex - Abocom */ \
	{USB_DEVICE(0x20F4, 0x648B)},/* TRENDnet - Cameo */ \
	{USB_DEVICE(0x4855, 0x0090)},/*  - Feixun */ \
	{USB_DEVICE(0x13D3, 0x3357)},/*  - AzureWave */ \
	{USB_DEVICE(0x0DF6, 0x005C)},/* Sitecom - Edimax */ \
	{USB_DEVICE(0x0BDA, 0x5088)},/* Thinkware - CC&C */ \
	{USB_DEVICE(0x4856, 0x0091)},/* NetweeN - Feixun */ \
	{USB_DEVICE(0x0846, 0x9041)}, /* Netgear - Cameo */ \
	{USB_DEVICE(0x0846, 0x9042)}, /* On Networks - N150MA */ \
	{USB_DEVICE(0x2019, 0x4902)},/* Planex - Etop */ \
	{USB_DEVICE(0x2019, 0xAB2E)},/* SW-WF02-AD15 -Abocom */ \
	{USB_DEVICE(0x2001, 0x330B)}, /* D-LINK - T&W */ \
	{USB_DEVICE(0xCDAB, 0x8010)}, /* - - compare */ \
	{USB_DEVICE(0x0B05, 0x17BA)}, /* ASUS - Edimax */ \
	{USB_DEVICE(0x0BDA, 0x1E1E)}, /* Intel - - */ \
	{USB_DEVICE(0x04BB, 0x094c)}, /* I-O DATA - Edimax */ \
	/****** 8188CTV ********/ \
	{USB_DEVICE(0xCDAB, 0x8011)}, /* - - compare */ \
	{USB_DEVICE(0x0BDA, 0x0A8A)}, /* Sony - Foxconn */ \
	/****** 8188 RU ********/ \
	{USB_DEVICE(0x0BDA, 0x317F)},/* Netcore,Netcore */ \
	/****** 8188CE-VAU ********/ \
	{USB_DEVICE(0x13D3, 0x3359)},/*  - Azwave */ \
	{USB_DEVICE(0x13D3, 0x3358)},/*  - Azwave */ \
	/****** 8188CUS Slim Solo********/ \
	{USB_DEVICE(0x04F2, 0xAFF7)},/* XAVI - XAVI */ \
	{USB_DEVICE(0x04F2, 0xAFF9)},/* XAVI - XAVI */ \
	{USB_DEVICE(0x04F2, 0xAFFA)},/* XAVI - XAVI */ \
	/****** 8188CUS Slim Combo ********/ \
	{USB_DEVICE(0x04F2, 0xAFF8)},/* XAVI - XAVI */ \
	{USB_DEVICE(0x04F2, 0xAFFB)},/* XAVI - XAVI */ \
	{USB_DEVICE(0x04F2, 0xAFFC)},/* XAVI - XAVI */ \
	{USB_DEVICE(0x2019, 0x1201)},/* Planex - Vencer */ \
	/****** 8192CUS Dongle ********/ \
	{USB_DEVICE(0x2001, 0x3307)},/* D-Link - Cameo */ \
	{USB_DEVICE(0x2001, 0x330A)},/* D-Link - Alpha */ \
	{USB_DEVICE(0x2001, 0x3309)},/* D-Link - Alpha */ \
	{USB_DEVICE(0x2001, 0x330D)},/* D-Link DWA-131 (H/W Ver. B1) */ \
	{USB_DEVICE(0x0586, 0x341F)},/* Zyxel - Abocom */ \
	{USB_DEVICE(0x7392, 0x7822)},/* Edimax - Edimax */ \
	{USB_DEVICE(0x2019, 0xAB2B)},/* Planex - Abocom */ \
	{USB_DEVICE(0x07B8, 0x8178)},/* Abocom - Abocom */ \
	{USB_DEVICE(0x07AA, 0x0056)},/* ATKK - Gemtek */ \
	{USB_DEVICE(0x4855, 0x0091)},/*  - Feixun */ \
	{USB_DEVICE(0x050D, 0x2102)},/* Belkin - Sercomm */ \
	{USB_DEVICE(0x050D, 0x2103)},/* Belkin - Edimax */ \
	{USB_DEVICE(0x20F4, 0x624D)},/* TRENDnet */ \
	{USB_DEVICE(0x0DF6, 0x0061)},/* Sitecom - Edimax */ \
	{USB_DEVICE(0x0B05, 0x17AB)},/* ASUS - Edimax */ \
	{USB_DEVICE(0x0846, 0x9021)},/* Netgear - Sercomm */ \
	{USB_DEVICE(0x0846, 0xF001)}, /* Netgear - Sercomm */ \
	{USB_DEVICE(0x0E66, 0x0019)},/* Hawking,Edimax */ \
	{USB_DEVICE(0x0E66, 0x0020)}, /* Hawking  - Edimax */ \
	{USB_DEVICE(0x050D, 0x1004)}, /* Belkin - Edimax */ \
	{USB_DEVICE(0x0BDA, 0x2E2E)}, /* Intel - - */ \
	{USB_DEVICE(0x2357, 0x0100)}, /* TP-Link - TP-Link */ \
	{USB_DEVICE(0x06F8, 0xE035)}, /* Hercules - Edimax */ \
	{USB_DEVICE(0x04BB, 0x0950)}, /* IO-DATA - Edimax */ \
	{USB_DEVICE(0x0DF6, 0x0070)}, /* Sitecom - Edimax */ \
	{USB_DEVICE(0x0DF6, 0x0077)}, /* Sitecom - Edimax */ \
	{USB_DEVICE(0x0789, 0x016D)}, /* LOGITEC - Edimax */ \
	/****** 8192CE-VAU  ********/ \
	{USB_DEVICE(USB_VENDER_ID_REALTEK, 0x8186)},/* Intel-Xavi( Azwave) */

%prep
%setup -qn %{pname}-%{version}
find -type f -exec chmod 0644 {} \;

%apply_patches

%install
%__rm -rf %{buildroot}
%__install -dm755 %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}
%__cp -a ./* %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}
%__rm -f %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}/{CONTRIBUTORS.md,LICENSE,README.md}
%__cat <<EOF > %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}/dkms.conf
PACKAGE_NAME="%{pname}"
PACKAGE_VERSION="%{version}-%{release}"
CLEAN="make clean"
MAKE="'make' SKIP_STACK_VALIDATION=1 all"
BUILT_MODULE_NAME="%{module}"
DEST_MODULE_LOCATION="/kernel/3rdparty/RTL8192CU"
AUTOINSTALL="yes"
EOF


%post -n %{name}
echo "blacklist rtlwifi" >> /etc/modprobe.d/blacklist
echo "blacklist rtl8192c_common" >> /etc/modprobe.d/blacklist
echo "blacklist rtl8192cu" >> /etc/modprobe.d/blacklist
echo "blacklist rtl8xxxu" >> /etc/modprobe.d/blacklist
/sbin/rmmod rtl8xxxu >/dev/null 2>&1
/sbin/rmmod rtlwifi >/dev/null 2>&1
/sbin/rmmod rtl8192c_common >/dev/null 2>&1
/sbin/rmmod rtl8192cu >/dev/null 2>&1

/usr/sbin/dkms --rpm_safe_upgrade add -m %{pname} -v %{version}-%{release}
/usr/sbin/dkms --rpm_safe_upgrade build -m %{pname} -v %{version}-%{release}
/usr/sbin/dkms --rpm_safe_upgrade install -m %{pname} -v %{version}-%{release}

if [ "$1" = 1 ]; then
/sbin/modprobe %{module} >/dev/null 2>&1
echo "Reloading network configuration ... "
/sbin/service network reload >/dev/null 2>&1
echo "%{module}" >> /etc/modprobe.preload
fi

%preun -n %{name}
/usr/sbin/dkms --rpm_safe_upgrade remove -m %{pname} -v %{version}-%{release} --all

if [ "$1" = 0 ]; then
/sbin/rmmod %{module} >/dev/null 2>&1
echo "Reloading network configuration ... "
/sbin/service network reload >/dev/null 2>&1
sed -i '/%{module}/ d' /etc/modprobe.preload
sed -i '/rtlwifi/ d' /etc/modprobe.d/blacklist
sed -i '/rtl8192c_common/ d' /etc/modprobe.d/blacklist
sed -i '/rtl8192cu/ d' /etc/modprobe.d/blacklist
sed -i '/rtl8xxxu/ d' /etc/modprobe.d/blacklist
fi

%clean
%__rm -rf %{buildroot}

%files
##doc README.md DESCRIPTION
##CONTRIBUTORS.md LICENSE 
%defattr(-,root,root)
%{_usrsrc}/%{pname}-%{version}-%{release}

%changelog
* Fri Aug 21 2020 onkelho <oh.quait at gmail.com> - 4.0.2-1pclos2020
- rebuild, switch to aur sources

* Tue Feb 27 2018 onkelho <oh.quait at gmail.com> 0.1-3pclos2018
- update from 2018.03.01 -fix timer stuff for 4.15..

* Mon Mar 13 2017 onkelho <oh.quait at gmail.com> 0.1-2pclos2017 
- Fix build with kernel 4.11
- first build this version

